#include "derivative.h" /* include peripheral declarations */
#include "main.h"
#include "Analog.h"

/****************************************************************
*AnalogOff     Turns the Analog converter off
*
*Input:  None
*Output: None
*
*Note: To turn back on just read an analog channel
****************************************************************/  
void AnalogOff(void){
  ADCSC1 = 0x1F;
}
 
/****************************************************************
*AnalogRead     Reads 1 analog channel and returns result
*
*Input:  data - channel to be read 0-5
*Output: result - result of analog conversion
*
*Note: Channels 0 and 1 are pressur sensors 1 and 2 respectively
****************************************************************/  
int AnalogRead(int data){
  int result;
  ADCSC1 = (char)data;       //initiates conversion
  while(ADCSC1_COCO==0);     //wait til conversion is done
  result = ADCR;             //Grab result
  return(result);
}

/****************************************************************
*PressOnOff     Turns On and Off power to pressure sensors
*
*Input:  Power1 - (0) Off, (1) On
*        Power2 - (0) Off, (1) On
*
*Output: None
*
*Note: On Off control is on pin PTB3 for Press1, and PTB2 for Press2 
****************************************************************/  
void PressOnOff(int Power1, int Power2){
  PTBD_PTBD3 = (char)Power1;
  PTBD_PTBD2 = (char)Power2;  
}