#include "derivative.h" /* include peripheral declarations */
#include "main.h"
#include "DAC.h"
#include "IIC.h"
#define DACADDRESS 0x4E

extern volatile char IICData[6];

/****************************************************************
*DACOnOff_Out     Write to the DAC
*
*Input:  data - mode and analog value data
*Output: 0 - free
*        1 - busy try again later 
*
*Note: There are 2 useless bits followed by 2 mode bits followed by 12 data bits
*XXMMDDDD DDDDDDDD
* 00 = Normal Operation
* 11 = High Impedance
****************************************************************/
int DACOnOff_Out(int data){  
  return(IICOut(DACADDRESS,(char)((data>>8)&0xFF),(char)(data&0xFF)));  
}

