#include "derivative.h" /* include peripheral declarations */
#include "IIC.h"

//ICC
char IICData[6] = {0,0,0,0,0,0};

/****************************************************************
*IICOut     Used to output on the IIC
* 
*Input: address - address of IIC device
*Ouput: 0 - free
*       1 - busy try again later 
*
*Note:
* 
****************************************************************/
int IICOut(int address, int reg, int data){
  int busy=1;    
  if(IIC1C1_MST == 1)        //Check if interrupt in finished
    return(busy);            // 
  
  IIC1S_IICIF = 1;           //clear flag
  IIC1C1_TX = 1;             //transmit for address
  IIC1C1_MST = 1;            //Start Signal   
  IIC1D = (address<<1);      //address + write(0) 
  while(IIC1S_IICIF == 0);   //wait for transfer to complete
  IIC1S_IICIF = 1;           //clear flag
  IIC1D = reg;               //Register in IIC device
  while(IIC1S_IICIF == 0);   //wait for transfer to complete
  IIC1S_IICIF = 1;           //clear flag  
  IIC1D = data;              //Register in IIC device
  while(IIC1S_IICIF == 0);   //wait for transfer to complete
  IIC1S_IICIF = 1;           //clear flag  
  IIC1C1_MST = 0;            //Stop condition
  
  /*
  IICTxRx = 1;               //set to transmit for interrupt
  IICDataPt = IICData;       //set data pointer for interrupt 
  IIC1C1_TX = 1;             //transmit for address and data
  IIC1C1_MST = 1;            //Start Signal
  IIC1D = address<<1;        //address + write(0) , start transmitt
  */
  
  busy = 0;           
  return(busy);
}

/****************************************************************
*IICIn   
* 
*Input: None
*Ouput: 0 - free
*       1 - busy try again later
*
*Note:  Before call write data to IICDate[]
*
****************************************************************/
int IICIn(int address, int StartReg, int ByteCount){
  int busy=1; 
  char i;   
  if(IIC1C1_MST == 1)        //Check if interrupt in finished
    return(busy);            //  
  
  IIC1S_IICIF = 1;           //clear flag
  IIC1C1_TXAK = 0;           //yes ack
  IIC1C1_TX = 1;             //transmit for address
  IIC1C1_MST = 1;            //Start Signal   
  //IIC1S_IICIF = 1;           //clear flag
  IIC1D = (address<<1);      //address + write(0) 
  while(IIC1S_IICIF == 0);   //wait for transfer to complete
  IIC1S_IICIF = 1;           //clear flag
  IIC1D = StartReg;          //Register in IIC device
  while(IIC1S_IICIF == 0);   //wait for transfer to complete
  IIC1S_IICIF = 1;           //clear flag
  IIC1C1_RSTA = 1;           //Repeat start
  IIC1D = (address<<1)+1;    //address + read(0)
  while(IIC1S_IICIF == 0);   //wait for transfer to complete
  IIC1S_IICIF = 1;           //clear flag
  IIC1C1_TX = 0;             //switch to receive for reading from slave
  //IIC1C1_TXAK = 1;           //no ack
  i = IIC1D;                 //dummy read   
  while(IIC1S_IICIF == 0);   //wait for transfer to complete
  IIC1S_IICIF = 1;           //clear flag
  i = 0;
  while(ByteCount > 0){    
    if(ByteCount == 1)
      IIC1C1_TXAK = 1;         //no ack
    IICData[i] = IIC1D;        //read data received
    while(IIC1S_IICIF == 0);   //wait for transfer to complete
    IIC1S_IICIF = 1;           //clear flag
    ByteCount--;
    i++;
  }
  IIC1C1_MST = 0;            //Stop condition  
  
  /*
  IICTxRx = 10;              //set to receive for interrupt
  IICDataPt = IICData;       //set data pointer for interrupt
  IIC1C1_TX = 1;             //transmit for address
  IIC1C1_MST = 1;            //Start Signal   
  IIC1D = (IICData[0]<<1);   //address + write(0), start receive  
  */
  
  busy = 0;
  return(busy);
}