#include "derivative.h" /* include peripheral declarations */
#include "main.h"
#include "Math.h"

/****************************************************************
*SquareRoot     Finds square roots of a float
*
*Input:  data      -  number
*        accuracy  -  amount of allowable error
*
*Output: square root fo input data
*
*Note: 
****************************************************************/ 
float SquareRoot(float data, float accuracy){
  int j=0, k=0;
  float root=1, i;
  
  if(data == 0)             //account for zero
    return(data);           //
  
  if(data<0){               //acount for negative number
    data *= -1;             //
    k = 1;                  //
  }                         //
  i = data;                 //
  
  if(i>1){                  //for numbers larger than 1
    while(i>1){             //find number of digits (base 10)
      i /= 10;              //
      j++;                  //
    }                       //
    for(j/=2;j>0;j--)       //appoximate root (seed)
      root *= 10;           //
  }
  else{                     //for numbers smaller than 1
    while(i<=1){            //find number of placeholders (zeros in front of first non zero digit)
      i *= 10;              //
      j++;                  //
    }                       //
    for(j/=2;j>0;j--)       //approximate root (seed)
      root /= 10;           //
  }  
  do {                            //find square root
    i = root;                     //
    root = (root + (data/root))/2;//
    i -= root;                    //
    if(i<0)                       //
      i *= -1;                    //
  } while(i > accuracy);          //
  if(k==1)                        //
    root = -root;                 //
return(root);
}

