void init(void);
void WaitUs(int);
void Start20Hz(void);
void Stop20Hz(void);
void ReStart20Hz(void);
void interrupt isr_20Hz(void);
void Start16Hz(void);
void Stop16Hz(void);
void interrupt isr_16Hz(void);
void StartButton(void);
void StopButton(void);
void interrupt isr_Button(void);
void SCIOut8(int);
void SCIOut16(int);
void SCIOutStr(char* str);
void interrupt isr_SCIIn(void);
void output4Hex(unsigned short data);
void readUSBandBattery(void);
void getBattery(void);
void displayBattery(void);
void interrupt isr_rtc(void);
void disable_peripherals(void);
void enable_peripherals(void);

#define SUPPLY_VOLTAGE 4.99
#define USB_ANALOG_CHAN       5   // using AN5 as analog input for +5V_USB
#define BATTERY_ANALOG_CHAN   6   // using AN6 (pot) as analog input for battery
#define BACKLIGHT_ON_THRESHOLD 3.55  // voltage must be above this to turn on backlight
#define LOW_BATTERY_THRESHOLD 3.40  // below this is one bar

#define OLD_SUPPLY_VOLTAGE 4.02   // to remain consistent with old blow by calculations
#define LCD_STRING_LENGTH 33
#define EEPROM_BASE 0x3C00

#define NBACKLIGHT PTBD_PTBD1

#define YEAR0   1900

extern unsigned char SCIstate, SCItempcmd, lastDumpCommand;
extern volatile unsigned char SCIcommand;
extern unsigned short CS;

extern volatile char Buttons;

// USB/serial commands
#define ASCII_DUMP  1       // "AD"
#define BIN_DUMP    2       // "BD"
#define START_REC   3       // "SR"
#define STOP_REC    4       // "ST"
#define ERASE_REC   5       // "ER"
#define FLOW_START  6       // Ctrl-Q
#define FLOW_STOP   7       // Ctrl-S
#define SET_DATETIME  8     // "SD"
#define DISPLAY_DATETIME  9 // "DD"
#define SET_OPTIONS  10     // "SO"
#define DISPLAY_OPTIONS  11 // "DO"
#define RESTORE_DEFAULTS 12 // "RD"
#define LOCK_OPTIONS     13 // "LO"
#define UNLOCK_OPTIONS   14 // "UN"

